unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, ExtCtrls, trayicon, Menus,stringutils, LbCipher,
  LbClass,inifiles,idexception;

type
  TFMain = class(TForm)
    IdHTTP1: TIdHTTP;
    Timer1: TTimer;
    ti: TTrayIcon;
    PopupMenu1: TPopupMenu;
    Configure1: TMenuItem;
    Exit1: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    eip: TLabeledEdit;
    epw: TLabeledEdit;
    Log1: TMenuItem;
    des: TLb3DES;
    GroupBox1: TGroupBox;
    cavs: TCheckBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    coldlg: TColorDialog;
    caot: TCheckBox;
    Timer2: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure Configure1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure tiDblClick(Sender: TObject);
    procedure tiRightClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Log1Click(Sender: TObject);
    procedure epwChange(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure doinit;
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure caotClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    pwchanged:boolean;
    init:boolean;
    ip:string;
  public
    { Public declarations }
    constructor create(aowner:tcomponent);override;
  end;

var upcol,dncol,upcol2,dncol2:TColor;
const linecol=clgreen;
var
  FMain: TFMain;
var ls,lr:int64;
    u,d:integer;
    ini:TMeminifile;

implementation

uses logs;

{$R *.dfm}

constructor tFMain.create;
begin
inherited;
hide;
end;

procedure TFMain.Timer1Timer(Sender: TObject);
var str:string;
    start,stop{,num}:integer;
    snt,recvd:int64;
    av:TNetPoint;

//draw the icon to the tray using andmask and xormask
procedure DrawIcon(const AndMask,XOrMask:TBitmap);
var icon:TIcon;
  IconInfo : TIconInfo;
begin
 {Create a icon}
  Icon := TIcon.Create;
  IconInfo.fIcon := true;
  IconInfo.xHotspot := 0;
  IconInfo.yHotspot := 0;
  IconInfo.hbmMask := AndMask.Handle;
  IconInfo.hbmColor := XOrMask.Handle;
  Icon.Handle := CreateIconIndirect(IconInfo);

 {Destroy the temporary bitmaps}
  AndMask.Free;
  XOrMask.Free;

 {Force a repaint}
  ti.Icon.Assign(icon);
 {Free the icon}
  Icon.Free;
end;

//draw the icon bars a1,b1 should be 0-1
procedure DrawIBars(const a1,b1:real);
var
  IconSizeX : integer;
  IconSizeY : integer;
  AndMask : TBitmap;
  XOrMask : TBitmap;
  a,b:integer;
begin
 {Get the icon size}
  IconSizeX := GetSystemMetrics(SM_CXICON);
  IconSizeY := GetSystemMetrics(SM_CYICON);
  a:=trunc(iconsizey *a1);
  b:=trunc(iconsizey *b1);
  if a>=iconsizey then a:=iconsizey-1;
  if b>=iconsizey then b:=iconsizey-1;
 {Create the "And" mask}
  AndMask := TBitmap.Create;
  AndMask.Monochrome := true;
  AndMask.Width := IconSizeX;
  AndMask.Height := IconSizeY;

 {Draw on the "And" mask}
  AndMask.Canvas.Brush.Color := clWhite;
  AndMask.Canvas.FillRect(Rect(0, 0, IconSizeX, IconSizeY));
  andmask.Canvas.Brush.Color:=clblack;
  andmask.Canvas.Pen.Color:=clblack;
  andmask.Canvas.Rectangle(0,iconsizey-a,iconsizex shr 1,iconsizey);
  andmask.Canvas.Rectangle(iconsizex shr 1,iconsizey-b,iconsizex,iconsizey);

 {Draw as a test}

 {Create the "XOr" mask}
  XOrMask := TBitmap.Create;
  XOrMask.Width := IconSizeX;
  XOrMask.Height := IconSizeY;

 {Draw on the "XOr" mask}
  XOrMask.Canvas.Brush.Color := ClBlack;
  XOrMask.Canvas.FillRect(Rect(0, 0, IconSizeX, IconSizeY));
  xormask.Canvas.Brush.Color:=upcol;
  xormask.Canvas.Pen.Color:=upcol;
  xormask.Canvas.Rectangle(0,iconsizey-a,iconsizex shr 1,iconsizey);
  xormask.Canvas.Brush.Color:=dncol;
  xormask.Canvas.Pen.Color:=dncol;
  xormask.Canvas.Rectangle(iconsizex shr 1,iconsizey-b,iconsizex,iconsizey);
  drawicon(AndMask,XORMask);
end;

//draw a question mark
procedure DrawQ;
var
  IconSizeX : integer;
  IconSizeY : integer;
  AndMask : TBitmap;
  XOrMask : TBitmap;
begin
 {Get the icon size}
  IconSizeX := GetSystemMetrics(SM_CXICON);
  IconSizeY := GetSystemMetrics(SM_CYICON);
 {Create the "And" mask}
  AndMask := TBitmap.Create;
  AndMask.Monochrome := true;
  AndMask.Width := IconSizeX;
  AndMask.Height := IconSizeY;

 {Draw on the "And" mask}
  AndMask.Canvas.Brush.Color := clWhite;
  AndMask.Canvas.FillRect(Rect(0, 0, IconSizeX, IconSizeY));
  andmask.Canvas.Brush.Color:=clwhite;
  andmask.Canvas.font.Color:=clblack;
  andmask.Canvas.Font.Size:=iconsizex -4;
  andmask.Canvas.textout((IconSizeX-andmask.Canvas.TextWidth('?')) shr 1,(IconSizeY-andmask.Canvas.TextHeight('?')) shr 1,'?');

 {Draw as a test}

 {Create the "XOr" mask}
  XOrMask := TBitmap.Create;
  XOrMask.Width := IconSizeX;
  XOrMask.Height := IconSizeY;

 {Draw on the "XOr" mask}
  XOrMask.Canvas.Brush.Color := ClBlack;
  XOrMask.Canvas.FillRect(Rect(0, 0, IconSizeX, IconSizeY));
  xormask.Canvas.Brush.Color:=clblack;
  xormask.Canvas.font.Color:=upcol;
  xormask.Canvas.Font.Size:=iconsizex -4;
  xormask.Canvas.textout((IconSizeX-andmask.Canvas.TextWidth('?')) shr 1,(IconSizeY-andmask.Canvas.TextHeight('?')) shr 1,'?');
  drawicon(AndMask,XORMask);
end;

begin
  try
     //get ppp status
     str:= idhttp1.Get(format('http://%s/doc/ppp.htm',[ip]));
     except on e:Exception do begin
            //increase interval to 1 minute
            if (timer1.Interval<>60000)or(sender=self) then begin
               timer1.interval:=60000;
               if e is EIDHttpProtocolException then showmessage('Incorrect Password') else
                  if e is EIDSocketerror then showmessage('Couldn''t find router. Check IP address') else
                     showmessage(e.Message);
               end;
            //draw question mark
            drawq;
            exit;
            end;
     end;
  //initalise values
  if not init then doinit;
  timer1.interval:=1000;
  //find upload bytes
  start:=search(str,'st_ppp_send_bytes_vc[0]');
  start:=start+length('st_ppp_send_bytes_vc[0] = "');
  stop:=searchfrom(str,'"',start)-1;
  snt:=strtoint64(getsub(str,start,stop));
  //find download bytes
  start:=stop+10;
  start:=searchfrom(str,'"',start)+1;
  stop:=searchfrom(str,'"',start)-1;
  recvd:=strtoint64(getsub(str,start,stop));
  //add to history
  try
     flogs.AddPoint((snt-ls)shr 10,(recvd-lr)shr 10);
     //get 4 second average
     if cavs.Checked then av:=flogs.avhist.getlast
        else av:=flogs.Hist.getlast;
     except end;
  drawibars(av.up/u,av.down/d);
  ti.hint:=format('%dkb/s %dkb/s',[av.up,av.down]);
  //store current status
  ls:=snt;
  lr:=recvd;
end;

procedure TFMain.Configure1Click(Sender: TObject);
begin
windowstate:=wsnormal;
fmain.Show;
end;

procedure TFMain.Exit1Click(Sender: TObject);
begin
fmain.Close;
end;

procedure TFMain.tiDblClick(Sender: TObject);
begin
windowstate:=wsnormal;
fmain.Show;
end;

procedure TFMain.tiRightClick(Sender: TObject);
begin
ti.dopopup;
end;

procedure TFMain.Button1Click(Sender: TObject);
begin
windowstate:=wsminimized;
end;

procedure TFMain.FormResize(Sender: TObject);
begin
if windowstate=wsminimized then fmain.Hide;
end;

procedure TFMain.FormCreate(Sender: TObject);
begin
  //hide the form from the start bar
ShowWindow(Application.Handle, SW_HIDE);
  SetWindowLong(Application.Handle, GWL_EXSTYLE,
    GetWindowLong(Application.Handle, GWL_EXSTYLE)
    or WS_EX_TOOLWINDOW );
  ShowWindow(Application.Handle, SW_SHOW);
    //load settings
  ini:=tmeminifile.Create('NetMon.ini');
  eip.Text:=ini.ReadString('','IP','10.0.0.2');
  ip:=eip.Text;
  des.GenerateKey('key removed'); //original key removed for security
  epw.Text:=ini.ReadString('','Password',des.EncryptString('conexant'));
  idhttp1.Request.Password:=des.DecryptString(epw.Text);
  upcol:=ini.ReadInteger('','upcol',clred);
  upcol2:=ini.ReadInteger('','upcol2',clmaroon);
  dncol:=ini.ReadInteger('','dncol',clblue);
  dncol2:=ini.ReadInteger('','dncol2',clnavy);
  cavs.Checked:=ini.ReadBool('','av',true);
  caot.Checked:=ini.ReadBool('','aot',false);
  pwchanged:=false;
end;

procedure tFMain.doinit;
var str:string;
    start,stop:integer;
begin
//initialise netmon
init:=false;
try
   //get adsl status
   str:= idhttp1.Get(format('http://%s/doc/adsl.htm',[ip]));
   //get max downstream speed
   start:=search(str,'st_dw_data_rate = "')+length('st_dw_data_rate = "');
   stop:=searchfrom(str,'"',start)-1;
   d:=strtoint(getsub(str,start,stop)) shr 3;
   //get max upstream speed
   start:=stop+10;
   start:=searchfrom(str,'"',start)+1;
   stop:=searchfrom(str,'"',start)-1;
   u:=strtoint(getsub(str,start,stop))shr 3;
   str:= idhttp1.Get(format('http://%s/doc/ppp.htm',[ip]));
   //find upload bytes
   start:=search(str,'st_ppp_send_bytes_vc[0]');
   start:=start+length('st_ppp_send_bytes_vc[0] = "');
   stop:=searchfrom(str,'"',start)-1;
   ls:=strtoint64(getsub(str,start,stop));
   //find download bytes
   start:=stop+10;
   start:=searchfrom(str,'"',start)+1;
   stop:=searchfrom(str,'"',start)-1;
   lr:=strtoint64(getsub(str,start,stop));
   init:=true;
   except show;
   end;
end;

procedure TFMain.Button2Click(Sender: TObject);
begin
close;
end;

procedure TFMain.Log1Click(Sender: TObject);
begin
flogs.Show;
end;

procedure TFMain.epwChange(Sender: TObject);
begin
pwchanged:=true;
end;

procedure TFMain.FormHide(Sender: TObject);
begin
//update settings
timer1.Enabled:=false;
ip:=eip.Text;
if pwchanged then begin
   epw.Text:=des.EncryptString(epw.Text);
   idhttp1.Request.Password:=des.DecryptString(epw.Text);
   pwchanged:=false;
   end;
timer1timer(sender);
timer1.Enabled:=true;
end;

procedure TFMain.FormClose(Sender: TObject; var Action: TCloseAction);
var ch:boolean;
begin
timer1.Enabled:=false;
//save settings
ch:=false;
if ini.ReadString('','IP','10.0.0.2')<>ip then begin
   ini.WriteString('','IP',eip.Text);
   ch:=true;
   end;
if ini.ReadString('','Password',des.EncryptString('conexant'))<>epw.Text then begin
   ini.WriteString('','Password',epw.Text);
   ch:=true;
   end;
if ini.ReadInteger('','upcol',clred)<>upcol then begin
   ini.WriteInteger('','upcol',upcol);
   ch:=true;
   end;
if ini.ReadInteger('','upcol2',clmaroon)<>upcol2 then begin
   ini.WriteInteger('','upcol2',upcol2);
   ch:=true;
   end;
if ini.ReadInteger('','dncol',clblue)<>dncol then begin
   ini.WriteInteger('','dncol',dncol);
   ch:=true;
   end;
if ini.ReadInteger('','dncol2',clnavy)<>dncol2 then begin
   ini.WriteInteger('','dncol2',dncol2);
   ch:=true;
   end;
if ini.ReadBool('','av',true)<>cavs.Checked then begin
   ini.WriteBool('','av',cavs.Checked);
   ch:=true;
   end;
if ini.ReadBool('','aot',false)<>caot.Checked then begin
   ini.WriteBool('','aot',caot.Checked);
   ch:=true;
   end;
if ch then ini.UpdateFile;
ini.Free;
end;

procedure TFMain.Button3Click(Sender: TObject);
begin
coldlg.Color:=upcol;
if coldlg.Execute then upcol:=coldlg.Color;
end;

procedure TFMain.Button4Click(Sender: TObject);
begin
coldlg.Color:=upcol2;
if coldlg.Execute then upcol2:=coldlg.Color;
end;

procedure TFMain.Button5Click(Sender: TObject);
begin
coldlg.Color:=dncol;
if coldlg.Execute then dncol:=coldlg.Color;
end;

procedure TFMain.Button6Click(Sender: TObject);
begin
coldlg.Color:=dncol2;
if coldlg.Execute then dncol2:=coldlg.Color;
end;

procedure TFMain.caotClick(Sender: TObject);
begin
if not init then exit;
if caot.Checked then flogs.FormStyle:=fsstayontop else flogs.FormStyle:=fsnormal;
end;

procedure TFMain.Timer2Timer(Sender: TObject);
begin
timer2.Enabled:=false;
windowstate:=wsminimized;
end;

end.
