unit trayicon;

interface

uses
  Windows, Messages, SysUtils, Classes,menus,controls,shellapi,forms,dialogs,graphics;

const Message_Handle=WM_User+19;

type
  TTrayIcon = class(tcomponent)
  private
    { Private declarations }
    FHandle:HWND;
    FPopupMenu:TPopupmenu;
    FDblClick:TNotifyEvent;
    FLeftClick:TNotifyEvent;
    FRightClick:TNotifyEvent;
    TrayIcon:NOTIFYICONDATA;
    FHint:string;
    FIcon:TIcon;
    procedure IconChanged(Sender: TObject);
    procedure sethint(value:string);
    procedure seticon(value:TIcon);
    Procedure WndProc(var msg : TMessage);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    procedure WMTray(var Msg: TMessage);
    procedure dopopup;
  published
    { Published declarations }
    property PopupMenu:TPopUpMenu read FPopupMenu write FPopupMenu;
    property OnDblClick:TNotifyEvent read FDblClick write FDblClick;
    property OnLeftClick:TNotifyEvent read FleftClick write FleftClick;
    property OnRightClick:TNotifyEvent read FrightClick write FrightClick;
    Property Hint:string read FHint write SetHint;
    property Icon:Ticon read ficon write seticon;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Additional', [TTrayIcon]);
end;

procedure ttrayicon.iconchanged;
begin
trayicon.hIcon:=ficon.Handle;
Shell_NotifyIcon(NIM_MODIFY, @TrayIcon);
end;

constructor ttrayicon.Create;
begin
inherited create(aowner);
ficon:=ticon.Create;
ficon.OnChange:=iconchanged;
fhandle:=classes.allocatehwnd(wndproc);
trayicon.cbSize:=sizeof(trayicon);
trayicon.Wnd:=fHandle;
trayicon.uID:=1;
trayicon.uFlags:=NIF_ICON or NIF_MESSAGE or NIF_TIP;
trayicon.uCallbackMessage:=Message_Handle;
if not(csdesigning in componentstate) then begin
   Shell_NotifyIcon(NIM_ADD, @TrayIcon);
   end;
end;

procedure ttrayicon.WMTray;
begin
case Msg.lParam of
     WM_LBUTTONDBLCLK: if assigned(ondblclick) then ondblclick(self);
     WM_LBUTTONUP:if assigned(onleftclick) then onleftclick(self);
     WM_RBUTTONUP:if assigned(onrightclick) then onrightclick(self);
     end;
end;

procedure ttrayicon.sethint;
var i:integer;
begin
fhint:=value;
if (length(fhint)>64) then begin
   if csdesigning in componentstate then showmessage('This hint will be truncated to 64 characters');
   setlength(fhint,64);
   end;
for i := 0 to length(fhint)-1 do
    trayicon.szTip[i]:=fhint[i+1];
for i := length(fhint) to 63 do
    trayicon.szTip[i]:=#0;
if not(csdesigning in componentstate) then begin
   Shell_NotifyIcon(NIM_MODIFY, @TrayIcon);
   end;
end;

procedure ttrayicon.seticon;
begin
if ficon <> nil then ficon.Free;
ficon.assign(value);
trayicon.hIcon:=ficon.Handle;
if not(csdesigning in componentstate) then begin
   Shell_NotifyIcon(NIM_MODIFY, @TrayIcon);
   end;
end;

destructor ttrayicon.Destroy;
begin
inherited destroy;
Shell_NotifyIcon(NIM_DELETE, @TrayIcon);
classes.deallocatehwnd(fhandle);
end;

procedure TTrayIcon.WndProc(var msg : TMessage);
begin
   if (msg.msg = Message_handle) then wmtray(msg)
     else msg.Result := DefWindowProc(FHandle, Msg.msg, msg.wParam, msg.lParam);
end;

procedure TTrayIcon.dopopup;
var curpos:TPoint;
begin
getcursorpos(curpos);
fpopupmenu.Popup(curpos.x,curpos.y);
end;

end.
 